SystemOrganization addCategory: #ParcialSabaterPicanol!
SystemOrganization addCategory: #'ParcialSabaterPicanol-Tests'!

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialSabaterPicanol'!

!Matriu class methodsFor: 'instance creation' stamp: 'JordiSabater 11/6/2012 17:10'!
new: unNombre
	"Retorna una matriu quadrada amb el numero de files indicat al argument unNombre"
	
	| matriu |
	matriu := super new: (unNombre*unNombre). 
	matriu n: unNombre.
	matriu setContents: (matriu collector).
	^ matriu.! !

!Matriu methodsFor: 'arithmetic' stamp: 'JordiSabater 11/8/2012 11:00'!
+ unaMatriu
	"Suma la matriu actual amb la matriu del argument unaMatriu i retorna una matriu nova resultat de la suma"

	^ (Matriu new: self n) setContents: (self asArray + unaMatriu asArray).! !

!Matriu methodsFor: 'arithmetic' stamp: 'JordiSabater 11/8/2012 11:12'!
- unaMatriu
	"Resta la matriu actual amb la matriu del argument unaMatriu i retorna una matriu nova resultat de la resta"

	^ (Matriu new: self n) setContents: (self asArray - unaMatriu asArray).! !

!Matriu methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 17:33'!
at: unParellEnter
	"Retorna el objecte de la matriu que es troba en la posicio determinada pel argument unParell"

	| posicio |
	posicio := (unParellEnter x - 1) * self n + unParellEnter y.
	^ super at: posicio.! !

!Matriu methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 17:33'!
at: unParellEnter put: unValor
	"posa el valor del argument unValor en la posicio de la matriu que indica el argument unParellEnter"

	| posicio |
	posicio := (unParellEnter x - 1) * self n + unParellEnter y.
	super at: posicio put: unValor.
	! !

!Matriu methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 13:08'!
n
	^ n! !

!Matriu methodsFor: 'private' stamp: 'JordiSabater 11/6/2012 13:09'!
n: unNombre 
	n := unNombre ! !

!Array methodsFor: '*ParcialSabaterPicanol-Arithmetic' stamp: 'JordiSabater 11/8/2012 10:50'!
+ unArray
	"Suma el array amb el del argument unArray i retorna un nou array resultat de la suma"

	| index arraySuma |
	self size = unArray size ifFalse: [self error: 'No es poden sumar Array de diferents tamanys'].
	arraySuma := Array new: self size.
	index := 0.
	[(index := index + 1) <= self size] whileTrue: 
		[arraySuma at: index put: (self at: index) + (unArray at: index)].
	^ arraySuma.! !

!Array methodsFor: '*ParcialSabaterPicanol-Arithmetic' stamp: 'JordiSabater 11/8/2012 11:13'!
- unArray
	"Resta el array amb el del argument unArray i retorna un nou array resultat de la resta"

	| index arrayResta |
	self size = unArray size ifFalse: [self error: 'No es poden restar Array de diferents tamanys'].
	arrayResta := Array new: self size.
	index := 0.
	[(index := index + 1) <= self size] whileTrue: 
		[arrayResta at: index put: (self at: index) - (unArray at: index)].
	^ arrayResta.! !

Object subclass: #ParcialSabaterPicanol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialSabaterPicanol'!

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/8/2012 11:21'!
pregunta1
	"Per a la resolucio daquesta pregunta sha creat la classe Matriu i la classe Parell que es troben en aquest mateix paquet. 
	A ms, per a poder comprovar el seu funcionament shan creat uns tests dins el paquet ParcialSabaterPicanol-Tests.
	Finalment cal dir que per a facilitar la suma i resta de matrius sha afegit una extensio a la classe Array amb els metodes + i -."

! !

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/8/2012 12:06'!
pregunta2
	"Introspeccio es la habilitat que te un programa per a poder observar, i per tant raonar, el seu propi estat mentre aquest es troba en execucio."
	
	"Intercessio es la habilitat que te un programa per a poder modificar el seu propi estat aixi com afegir nous comportaments al programa mentre 
	aquest es troba en execucio."
	
	"Reificacio es el mecanisme que permet obtenir lestat dexecucio del programa codificat com a dades."
	
	"----------------------------------------------------------------------------------------------------------------------------------------------------------"
	
	"Lorientacio de Smalltalk a que tot sigui un objecte aconsegueix que sigui molt mes reflexiu que Java, per exemple fins i tot la pila dexecucio
	es un objecte amb metodes per a fer introspreccio e intercessio. Smalltalk permet modificar les meteclasses dinamicament mentre que Java
	no ho permet. Java te molts metodes dins la llibreria reflections que permet aconseguir un bon grau dintrospeccio pero en definitiva es poc 
	intercessiu."
	
	"Aixi doncs podem dir que cap dels dos llenguatges es reflexiu del tot ja que tenen limitacions pero Smalltalk sapropa mes a serho que no pas
	java."
! !

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/8/2012 15:26'!
pregunta3
	"Com que una classe es un objecte i tot objecte es instancia duna classe a la seva vegada, calen les metaclasses per 
	tal de poder instanciar les classes i contenir la informacio sobre elles. Aixo genera un bucle que Smalltalk i Java solucionen 
	de maneres diferents."
	
	"En Smalltalk cada classe x es instancia de la seva metaclass x class, i cada metaclass x class es a instancia de meteclass, 
	que te la seva propia meteclass class class que a la seva vegada es instancia de meteclass."
	
	"En Java la soluci es diferent. Cada classe es instancia de la metaclass java.lang.Class que a la seva vegada es instancia
	della mateixa."
	
	"El fet de poder accedir a les meteclasses permet canviar el comportament que tindran les classes durant  lexecucio del 
	programa o consultar informacio sobre la classe (reflexi)."
	
	"La diferencia entre la manera que solucina Java el bucle i la manera en que ho fa Smalltalk te les seves consequencies.
	En Smalltalk es permet accedir a la propia metaclasse de cada classe per tal de modificar el seu comportament com 
	comentavem al paragraf anterior. Mentre que en Java nomes pots accedir a la classe que com a instancia de java.lang.Class
	te molts metodes per a fer introspeccio pero no per a intercessio."! !

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/9/2012 12:07'!
pregunta4
	"Els elements de la pila dexecucio que reifica thisContext son de la classe #MethodContext.  Aquesta classe conte el program counter, 
	el metode, el sender (que correspon al metode previ i per tant on retornarem al finalitzar lexecucio del metode actual) i el receiver."
	
	"Si dins dun metode m qualsevol retorno un valor amb ^expressio, respecte a thisContext ^expressio retornara al sender del #MethodContext 
	del metode m. Es a dir retorna al metode que ha invocat el missatge m."

	| temporary |
	temporary := [	thisContext explore. 
		^2 + 2. ] value.
	^temporary.
	
	"Si dins del mateix metode m el que savalua es un bloc que conte ^expressio com en el codi dexemple anterior el que passa es que el bloc es 
	reifica en thisContext com un metode diferent de m amb el seu propi #MethodContext , que retornara al seu sender que correspon al metode m que avalua
	el bloc."! !

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/9/2012 12:17'!
pregunta5: aSelector
	"Aquest metode es una parada condicional. Nomes satura amb un Halt si un metode amb un selector que
	coincideixi amb el de largument aSelector ha estat invocat per algun altre metode."

	| context |
	context := thisContext.
	[context sender isNil] whileFalse:
		[context := context sender.
		(context selector = aSelector) ifTrue:
		[Halt signal]].! !

!ParcialSabaterPicanol methodsFor: 'as yet unclassified' stamp: 'JordiSabater 11/9/2012 13:04'!
pregunta6
"
	public static void haltIf(String selector) {
	       Thread t = Thread.currentThread();
	       int profunditat = t.getStackTrace().length;    
	       for (int i = 0; i < profunditat; i++) {
	           String metode = t.getStackTrace()[i].getMethodName();
	           if(metode.equals(selector)) {
	               /*Com que en Smalltalk tot es un objecte, fins i tot el debugger,
	        	   aquest es pot invocar dinamicament. Pero en Java aixo no es pot fer
	        	   facilment. Dins daquesta condicio aniria quelcom que es vulgui 
	        	   fer per parar lexecucio (Halt).*/
	           }
	       }     
	   }
"! !

Object subclass: #Parell
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialSabaterPicanol'!

!Parell methodsFor: 'comparing' stamp: 'JordiSabater 11/6/2012 15:27'!
= unParell

	^  x = unParell x and: [ y = unParell y]! !

!Parell methodsFor: 'modifier' stamp: 'JordiSabater 11/6/2012 15:45'!
intercanviar
	"Intercanvia els valors x e y del parell"	
		
	|auxiliar|
	auxiliar := self x.
	self x: y.
	y := auxiliar .	! !

!Parell methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 13:34'!
x
	^ x! !

!Parell methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 15:13'!
x: unObjecte
	x := unObjecte! !

!Parell methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 13:34'!
y
	^ y! !

!Parell methodsFor: 'accessing' stamp: 'JordiSabater 11/6/2012 15:13'!
y: unObjecte
	y := unObjecte! !

TestCase subclass: #MatriuTest
	instanceVariableNames: 'parell matriu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialSabaterPicanol-Tests'!

!MatriuTest methodsFor: 'initialize-release' stamp: 'JordiSabater 11/6/2012 17:40'!
setUp
	parell := Parell new x: 2 ; y: 3.
	matriu := Matriu new: 5.! !

!MatriuTest methodsFor: 'tests' stamp: 'JordiSabater 11/6/2012 17:39'!
testGetISet

	self assert: (matriu at: parell) = nil.
	matriu at: parell put: 3.
	self assert: (matriu at: parell) = 3.
	parell intercanviar.
	self assert: (matriu at: parell) = nil.
	! !

!MatriuTest methodsFor: 'tests' stamp: 'JordiSabater 11/8/2012 11:15'!
testResta
	
	|matriu1 matriu2 matriuResta parell1 parell2 parell3 parell4 |
	parell1 := Parell new x: 1 ; y: 1.
	parell2 := Parell new x: 1 ; y: 2.
	parell3 := Parell new x: 2 ; y: 1.
	parell4 := Parell new x: 2 ; y: 2.
	matriu1 := Matriu new: 2.
	matriu1 at: parell1 put: 10.
	matriu1 at: parell2 put: 20.
	matriu1 at: parell3 put: 30.
	matriu1 at: parell4 put: 40.
	matriu2 := Matriu new: 2.
	matriu2 at: parell1 put: 40.
	matriu2 at: parell2 put: 20.
	matriu2 at: parell3 put: 30.
	matriu2 at: parell4 put: 40.
	matriuResta := matriu1 - matriu2.
	self assert: ((matriuResta at: parell1) = -30).
	self assert: ((matriuResta at: parell2) = 0).
	self assert: ((matriuResta at: parell3) = 0).
	self assert: ((matriuResta at: parell4) = 0).! !

!MatriuTest methodsFor: 'tests' stamp: 'JordiSabater 11/8/2012 11:11'!
testSuma
	
	|matriu1 matriu2 matriuSuma parell1 parell2 parell3 parell4 |
	parell1 := Parell new x: 1 ; y: 1.
	parell2 := Parell new x: 1 ; y: 2.
	parell3 := Parell new x: 2 ; y: 1.
	parell4 := Parell new x: 2 ; y: 2.
	matriu1 := Matriu new: 2.
	matriu1 at: parell1 put: 10.
	matriu1 at: parell2 put: 20.
	matriu1 at: parell3 put: 30.
	matriu1 at: parell4 put: 40.
	matriu2 := Matriu new: 2.
	matriu2 at: parell1 put: 40.
	matriu2 at: parell2 put: 20.
	matriu2 at: parell3 put: 30.
	matriu2 at: parell4 put: 40.
	matriuSuma := matriu1 + matriu2.
	self assert: ((matriuSuma at: parell1) = 50).
	self assert: ((matriuSuma at: parell2) = 40).
	self assert: ((matriuSuma at: parell3) = 60).
	self assert: ((matriuSuma at: parell4) = 80).! !

TestCase subclass: #ParellTest
	instanceVariableNames: 'parellEnter parellEnterDiferent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialSabaterPicanol-Tests'!

!ParellTest methodsFor: 'initialize-release' stamp: 'JordiSabater 11/6/2012 15:40'!
setUp
	parellEnter := Parell new x: 50 ; y: 10.
	parellEnterDiferent := Parell new x: 10 ; y: 50.! !

!ParellTest methodsFor: 'tests' stamp: 'JordiSabater 11/6/2012 15:39'!
testIguals
	"|parellEnter|
	parellEnter = Parell new x: 50 ; y: 10."
	self assert: parellEnter = parellEnter.
	self assert: parellEnter = (Parell new x: 50 ; y: 10).
	self assert: parellEnter ~= parellEnterDiferent.! !

!ParellTest methodsFor: 'tests' stamp: 'JordiSabater 11/6/2012 17:20'!
testIntercanviar

	self assert: parellEnter = parellEnterDiferent intercanviar.! !
